import 'package:flutter/material.dart';
import 'package:i_sizing/i_sizing.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: PieView(),
    );
  }
}

class PieView extends StatelessWidget {
  const PieView({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final mediaSize = MediaQuery.of(context).size;

    final connectionI = 1.i(mediaSize: mediaSize);
    final count = numberOfI(boxWidth: mediaSize.width, i: connectionI);
    final connectioniCount = count - 1;
    print("Count: $connectioniCount");
    return Scaffold(
      body: Row(
        mainAxisAlignment: MainAxisAlignment.start,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Container(
            width: (connectioniCount * connectionI) as double,
            child: GridView.builder(
              physics: NeverScrollableScrollPhysics(),
              shrinkWrap: true,
              gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                crossAxisCount: (connectioniCount / 2).floor(),
                crossAxisSpacing: 0,
                mainAxisSpacing: 0,
              ),
              itemCount: 11,
              itemBuilder: (context, index) {
                return Container(
                  width: connectionI * 2, // or  1.i(mediaSize: mediaSize, times: 2),
                  height: connectionI * 2 ,
                  color: Colors.red,
                  padding: EdgeInsets.all(1.p(i: 1.i(mediaSize: mediaSize))),
                  child: Container(
                    color: Colors.blue,
                  ),
                );
              },
            ),
          ),
          Container(
            width: 1.i(mediaSize: mediaSize),
            color: Colors.green,
          )
        ],
      ),
    );
  }
}
