library i_sizing;

import 'dart:math';

import 'package:flutter/material.dart';

// actual millimeter on device
const int mm = 11;

const bool removeBorders = false;
// This constant:1 represent the ration of flutter logic pixel to millimeter on device screen.
const double mmValue = 6.299;

extension SizeExtension on num {
  ///mediaWidth width of the screen
  ///
  ///By Default times is 1
  double i(
      {required Size mediaSize, double? df, double? times, int? postNumber}) {
    // final iMillimeter = this * 6.299;
    times ??= 1;
    // num df = 1;
    if (df == null) {
      if (mediaSize.width < 480) {
        df = (1 * this * mm) / 10;
      } else if (mediaSize.width >= 480 && mediaSize.width < 1024) {
        df = (1.3 * this * mm) / 20;
      } else {
        df = (1.3 * 1.13 * this * mm) / 30;
      }
    }
    double widthInMm = mediaSize.width / mmValue;
    double i = (min(widthInMm, this * mm * 7) / 7) * df * mmValue;
    int value = 1;
    if (postNumber == null) {
      value = mediaSize.width ~/ i;
    } else {
      value = postNumber ~/ times;
    }
    double rem = mediaSize.width % i;
    if (rem >= 0.5) {
      i = mediaSize.width / (value + 1);
    } else {
      i = mediaSize.width / value;
    }

    return i * times;
  }

  // A 1X1 size post is 10pX10p , 10p ~= 1i
  double p({required double i}) {
    return this * (i / 10);
  }

  // The smallest font size for a text should be 2sp. Sizing can scale as integer value greater > 1
  double sp(double iValue) {
    return this.p(i: iValue) * 0.15.p(i: iValue);
  }
}

extension PreferredPostSize on String {
  // get prefer post size
  int get prefWidth => int.parse(this.split('x').last);
  int get prefHeight => int.parse(this.split('x').first);
}

int realHeight(
    {required int maxHeight, required String prefSize, int? pHeight}) {
  final thisHeight = prefSize.prefHeight;
  return pHeight != null && pHeight <= thisHeight ? pHeight : thisHeight;
}

int realWidth({required int maxWidth, required String prefSize, int? pWidth}) {
  final thisWidth = prefSize.prefWidth;
  return pWidth != null && pWidth <= thisWidth ? pWidth : thisWidth;
}

int numberOfI({required double i, required double boxWidth}) {
  print(boxWidth / i);
  return (boxWidth / i).floor();
}
